*! version 4.0
* 18 May 2016
* NIDS
* Master Income do file for Nids Wave 3

* THIS IS 5th INCOME DO FILE - PRE-IMPUTATION AGGREGATION DO FILE: 5 OF 7
* This file creates production-level and income variables for section h (agriculture) of the household questionaire

*=======================================================================================================================================================
* GLOBALS FOR DATA FILES, DO FILES AND VERSION SUFFIXES

*global DataIN "\\137.158.104.21\data\Wave 3\Final Data\NonAnon"
*global DataOUT "C:\Users\01406074\Desktop"

*global VersionIN "W3_Beta_V8_NonAnon"

version 12.1 
*========================================================================================================================================================

use "$DataIN\HHQuestionnaire_$VersionIN.dta", clear

cap rename hhid w3_hhid
merge 1:1 w3_hhid using "$DataIN\hhderived_$VersionIN.dta", keepusing(w3_dc2001)

*========================================================================================================================================================
*PREPARING THE DATA: SET NON-RESPONSE CODES TO SYSTEM MISSING

rename w3_h_* *
foreach var of varlist agcr	agcrml	agcrmlhkg	agcrmlsllyn	agcrmlskg	agcrmlval	agcrsor	agcrsorhkg	agcrsorsllyn	agcrsorskg	agcrsorval	agcrfrt	agcrfrthkg	agcrfrtsllyn	agcrfrtskg	agcrfrtval	agcrpot	agcrpothkg	agcrpotsllyn	agcrpotskg	agcrpotval	agcrpmp	agcrpmphkg	agcrpmpsllyn	agcrpmpskg	agcrpmpval	agcrmad	agcrmadhkg	agcrmadsllyn	agcrmadskg	agcrmadval	agcroni	agcronihkg	agcronisllyn	agcroniskg	agcronival	agcrdb	agcrdbhkg	agcrdbsllyn	agcrdbskg	agcrdbval	agcrgrnveg	agcrgrnveghkg	agcrgrnvegsllyn	agcrgrnvegskg	agcrgrnvegval	agls	aglscat	aglscatown	aglscatsll	aglscatval	aglscatcon	aglsshp	aglsshpown	aglsshpsll	aglsshpval	aglsshpcon	aglsgt	aglsgtown	aglsgtsll	aglsgtval	aglsgtcon	aglspig	aglspigown	aglspigsll	aglspigval	aglspigcon	aglshrs	aglshrsown	aglshrssll	aglshrsval	aglshrscon	aglsdnk	aglsdnkown	aglsdnksll	aglsdnkval	aglsdnkcon	aglschc	aglschcown	aglschcsll	aglschcval	aglschccon	ageggnum	ageggu	agcwmlkmth	agcwmlkamt	aggtmlkmth	aggtmlkamt	agilab	agilabspn	agifrt	agifrtspn	agiman	agimanspn	agichm	agichmspn	agiplgh	agiplghspn	agiseed	agiseedspn	agidip	agidipspn	agivet	agivetspn	agifeed	agifeedspn	agiinv	agiinvspn	agirep	agirepspn {
replace `var' = . if `var' <0
}

*========================================================================================================================================================
*PART 1 - INCOME FROM CROP PRODUCTION

*CREATING PRICE PER KG FOR EACH CROP

/*The farm gate price is used in cases where no crops were sold by the household. If crops were sold by the household, then the value per kg is calculated*/

**RERENCES TO PRICES

*DAFF (Department of Agriculture, Fisheries and Forestry) 2012 prices were obtained from http://www.daff.gov.za/docs/statsinfo/Abstact2013.pdf
*FW Farmers Weekly June 2012 Edition

		**Creating a per kg value for mealies** 
		*R2.144 per kg DAFF, R2.280 per kg FW 
		*W1 price = R2 (R1.606 DAFF 2008)
		gen  mealiekgprice = 2.144 if agcrml == 1 & agcrmlhkg> 0 &  agcrmlhkg!= . //369 hh harvested mealies, 19 hh sold
		replace  mealiekgprice= agcrmlval/ agcrmlskg if agcrmlval>0 & agcrmlval!= . & agcrmlskg> 0 & agcrmlskg!=.


		**Creating a per kg value for Sorghum**  
		*R2.674 per kg DAFF, R3.045 per kg FW
		*W1 price = R2 (R1.744 DAFF 2008)
		gen  sorghumkgprice= 2.674 if agcrsor == 1 &  agcrsorhkg > 0 &  agcrsorhkg!=.  //6 hh harvested sorghum, none sold
		replace sorghumkgprice= agcrsorval/agcrsorskg if agcrsorval>0 & agcrsorval!=. & agcrsorskg> 0 & agcrsorskg!= .

		
		**Creating a per kg value for fruit** 
		*DAFF R6.187 (average price for (5,258 apples; 6,445 appricots; 8,207 grapes; 4,841 pears))    
		*W1 price = R3.5(citrus fruit 1.5(deciduous fruit)) 
		gen  fruitkgprice= 6.187 if agcrfrt == 1 &  agcrfrthkg > 0 &  agcrfrthkg!=. //101 hh harvested fruit, 5 hh sold
		replace fruitkgprice= agcrfrtval/agcrfrthkg if agcrfrtval>0 & agcrfrtval!=. & agcrfrthkg> 0 & agcrfrthkg!= .
		
		
		**Creating a per kg value for potato**  
		*R3.148 Average of (R2.646 per kg potatoe, 3.650 per kg sweeet potatoe DAFF), R3.839 per kg FW
		*W1 price = R3 (R2.20  Average of (R2.076 potatoe & R2.325 sweet potatoes) DAFF 2008)
		gen  potatokgprice = 3.148 if agcrpot == 1 & agcrpothkg> 0 & agcrpothkg!=.
		replace  potatokgprice= agcrpotval/ agcrpotskg if agcrpotval>0 & agcrpotval!=. & agcrpotskg>0 & agcrpotskg!=.

		
		**Creating a per kg value for pumpkin**  
		*R2.013 Average of (R1.617 per kg pumpkin R2.409 butternut squash) DAFF, 
		*W1 price = R4  (R1.531  Average if (R1.250 pumpkin & R1.813 butternut squash) DAFF 2008 )
		gen  pumpkinkgprice = 2.013 if agcrpmp == 1 & agcrpmphkg > 0 & agcrpmphkg !=. 
		replace  pumpkinkgprice= agcrpmpval/ agcrpmpskg  if agcrpmpval >0 & agcrpmpval!=. & agcrpmpskg>0 & agcrpmpskg!=.


		**Creating a per kg value for madumbe** 
		*R3.650. We used the price of sweet potatoes fron DAFF
		*W1 price = R3
		gen  madumbekgprice= 3.650 if agcrmad == 1 & agcrmadhkg > 0 & agcrmadhkg !=.
		replace madumbekgprice = agcrmadval/ agcrmadskg if agcrmadval >0 & agcrmadval!=. & agcrmadskg >0 & agcrmadskg !=.


		**Creating a per kg value for Onions**  
		*R2.586 per kg DAFF, R2.453 per kg Farmers Weekly 25 Oct 2013 
		*W1 price = R4 (R2.167 DAFF 2008)
		gen  onionskgprice =  2.586 if agcroni == 1 & agcronihkg >0 & agcronihkg != .
		replace onionskgprice = agcronival/ agcroniskg if agcronival >0 & agcronival!=. & agcroniskg >0 & agcroniskg !=.


		**Creating a per kg value for legumes** 
		*R11.1135 Average of  (R14.00 Large white kidney beans, R8.318.00 Small white beans, R10.636 Sugar beans, R11.50 Haricot beans)	, R2.453 per kg FW
		*W1 price = R2
		gen  legumeskgprice= 11.1135 if agcrdb == 1 & agcrdbhkg >0 & agcrdbhkg !=.
		replace legumeskgprice = agcrdbval/ agcrdbskg if agcrdbval >0 & agcrdbval !=. & agcrdbskg >0 & agcrdbskg !=.


		**Creating a per kg value for green veg**  
		*R1.753 per kg (cabbage) DAFF, R2.032 per kg FW
		*W1 price = R2) (R1.080 DAFF 2008)
		gen  greenvegkgprice= 1.753 if agcrgrnveg == 1 & agcrgrnveghkg >0 & agcrgrnveghkg !=.
		replace greenvegkgprice = agcrgrnvegval/ agcrgrnvegskg if agcrgrnvegval >0 & agcrgrnvegval !=. & agcrgrnvegskg >= 0 & agcrgrnvegskg !=.


*-------------------------------------------------------------------------------------------------------------------

**CREATING AGRICULTURE INCOME AS PRICE PER KG * NUMBER OF KG HARVESTED

	*mealies Income
	gen mealieinc = agcrmlhkg*mealiekgprice
	replace mealieinc = agcrmlval if agcrmlhkg == . & agcrmlval >0 & agcrmlval!=.  
	//1 hh that does not know how much they harvested, but know how much money they received from selling mealies

	*Sorghum Income	
	gen sorghuminc = agcrsorhkg*sorghumkgprice

	*Fruit Income	
	gen fruitinc = agcrfrthkg*fruitkgprice
	
	*Potato Income
	gen potatoinc = agcrpothkg*potatokgprice
	replace potatoinc =  agcrpotval if agcrpothkg == . & agcrpotval >0 & agcrpotval !=. 
	//2 hh that do not know how much they harvested, but know how much money they received from selling potatoes

	*Pumpkin Income
	gen pumpkininc = agcrpmphkg*pumpkinkgprice
	
	*Madumbe Income 
	gen madumbeinc = agcrmadhkg*madumbekgprice
	replace  madumbeinc = agcrmadval if agcrmadhkg == . &  agcrmadval>0 & agcrmadval !=.
	//2 hh that do not know how much they harvested, but know how much money they received from selling madumbe
	
	*Onion Income
	gen onioninc = agcronihkg*onionskgprice
	replace onioninc = agcronival if agcronihkg == . & agcronival >0 & agcronival !=.
	//2 hh that do not know how much they harvested, but know how much money they received from selling onions

	*Legume Income
	gen legumeinc = agcrdbhkg*legumeskgprice
	
	*Green Veg income
	gen greenveginc = agcrgrnveghkg*greenvegkgprice


drop *price

*-------------------------------------------------------------------------------------------------------------------

*CALCULATING TOTAL INCOME FROM CROP PRODUCTION
egen produceinc = rowtotal(mealieinc sorghuminc fruitinc potatoinc pumpkininc madumbeinc onioninc legumeinc greenveginc)
 
 
 
 
 
 
*========================================================================================================================================================




*PART 2 - INCOME FROM LIVESTOCK  PRODUCE 



*ESTIMATING VALUE OF A SINGLE UNIT OF LIVESTOCK 

	**Creating price per cow value 
	*Use median of sample as price per cow for hh that did not sell any livestock
	*W1 price = R2 800)
	gen cowprice = .
	replace cowprice=aglscatval/aglscatsll
	egen cowprice_median = median(cowprice)  //Median price is R5000
	sum cowprice, d
	replace cowprice= cowprice_median if cowprice==. & (aglscatsll>0 & aglscatsll!=.) 
	replace cowprice= cowprice_median if cowprice==. & (aglscatcon>0 & aglscatcon!=.)
	drop cowprice_median
	
	**Creating price per sheep value 
	*Use median of sample as price per cow for hh that did not sell any livestock
	*W1 price = R600)
	gen sheepprice=.
	replace sheepprice=aglsshpval/aglsshpsll
	egen sheepprice_median = median(sheepprice) //Median price is R1000
	sum sheepprice, d	
	replace sheepprice=sheepprice_median if sheepprice==. & aglsshpsll>0 & aglsshpsll!=.
	replace sheepprice=sheepprice_median if sheepprice==. & aglsshpcon>0 & aglsshpcon!=.
	drop sheepprice_median
	
	**Creating price per goat value 
	*Use median of sample as price per cow for hh that did not sell any livestock 
	*W1 price = R500)
	gen goatprice=.
	replace goatprice=aglsgtval/aglsgtsll
	egen goatprice_median = median(goatprice) //Median price is R800
	sum goatprice, d	
	replace goatprice=goatprice_median if goatprice==. & aglsgtsll>0 & aglsgtsll!=.
	replace goatprice=goatprice_median if goatprice==. & aglsgtcon>0 & aglsgtcon!=.
	replace goatprice = goatprice_median if aglsgtsll>0 & aglsgtsll!=. & aglsgtval == 0 //1 hh, sold 2 goats and got R0
	drop goatprice_median
	
	**Creating price per pig value 
	*R600 per pig 
	*W1 price = R)
	gen pigprice=.
	replace pigprice=aglspigval/aglspigsll
	egen pigprice_median = median(pigprice) //Median price is R120
	sum pigprice, d
	replace pigprice=600 if pigprice==. & aglspigsll>0 & aglspigsll!=.  // Median price of R120 is too low so the maz price from the sample of 600 is assigned
	replace pigprice=600 if pigprice==. & aglspigcon>0 & aglspigcon!=.  // Median price of R120 is too low so the maz price from the sample of 600 is assigned
	drop pigprice_median
	
	**Creating price per horse value 
	*R1 200 per horse
	*W1 price = R1 000)
	gen horseprice=.
	replace horseprice=aglshrsval/aglshrssll
	egen horseprice_median = median(horseprice) //Median price is R5000
	sum horseprice, d
	replace horseprice=horseprice_median if horseprice==. & aglshrssll>0 & aglshrssll!=.
	replace horseprice=horseprice_median if horseprice==. & aglshrscon>0 & aglshrscon!=.
	drop horseprice_median
	
	**Creating price per donkey value 
	*R1 000 per donkey 
	*W1 price = R)
	gen donkeyprice=.
	replace donkeyprice=aglsdnkval/aglsdnksll
	egen donkeyprice_median = median(donkeyprice) //No household sold any donkeys do mo price was calculated from the sample
	sum donkeyprice, d
	replace donkeyprice=donkeyprice_median if donkeyprice==. & aglsdnksll>0 & aglsdnksll!=.
	replace donkeyprice=donkeyprice_median if donkeyprice==. & aglsdnkcon>0 & aglsdnkcon!=.
	drop  donkeyprice_median
	
	**Creating price per chicken value 
	*R40 per chicken
	*W1 price = R30)
	gen chickenprice=.
	replace chickenprice=aglschcval/aglschcsll
	egen chickenprice_median = median(chickenprice) //Median price is R45
	sum chickenprice, d
	replace chickenprice=chickenprice_median if chickenprice==. & aglschcsll>0 & aglschcsll!=.
	replace chickenprice=chickenprice_median if chickenprice==. & aglschccon>0 & aglschccon!=.
	replace chickenprice = chickenprice_median if aglschcsll>0 & aglschcsll!=. & aglschcval == 0 //1 hh, sold 2 goats and got R0
	drop chickenprice_median
	
*---------------------------------------------------------------------------------------------------

*LIVESTOCK INCOME
	egen num_cattle= rowtotal(aglscatsll aglscatcon)
	gen cattleinc = num_cattle*cowprice

	egen num_sheep = rowtotal(aglsshpsll aglsshpcon)
	gen sheepinc = num_sheep*sheepprice

	egen num_goat = rowtotal(aglsgtsll aglsgtcon)
	gen goatinc = num_goat*goatprice

	egen num_pig =  rowtotal(aglspigsll aglspigcon)
	gen piginc	= num_pig*pigprice

	egen num_horse = rowtotal(aglshrssll aglshrscon)
	gen horseinc = num_horse*horseprice

	egen num_donkey = rowtotal(aglsdnksll aglsdnkcon)
	gen donkeyinc = num_donkey*donkeyprice

	egen num_chicken = rowtotal(aglschcsll aglschccon)
	gen  chickeninc= num_chicken*chickenprice

*TOTAL INCOME FROM LIVESTOCK PRODUCE
	egen animalinc =  rowtotal(cattleinc goatinc sheepinc piginc horseinc donkeyinc chickeninc)

drop cattleinc sheepinc goatinc piginc horseinc donkeyinc chickeninc num_*



*========================================================================================================================================================




*PART 3 - INCOME FROM LIVESTOCK-RELATED PRODUCE


*INCOME FROM EGGS
	replace ageggu = 1 if ageggu ==. & ageggnum>0 & ageggnum!=. // ****NB: 12 hh with # egg >0 but no units (i.e. ageggu ==-9)
	gen eggunits=.
	replace eggunits = ageggnum*12 if ageggu==1


	replace eggunits = ageggnum if ageggu==2
	replace eggunits=-3 if eggunits==-108
	replace eggunits=-3 if eggunits==-36
	gen eggunitannual=.
	replace eggunitannual=eggunits*12
	replace eggunitannual=-3 if eggunitannual==-36
	replace eggunitannual=-3 if eggunitannual==-108

	*R0.7701 per egg DAFF 
	*W1 price = R0.50 (R0.6249 DAFF 2008)
	gen egginc=.
	replace egginc=eggunitannual* 0.7701

	

*INCOME FROM MILK OR SOUR MILK FROM COW
	
	gen cowmilklitre=.
	replace cowmilklitre = agcwmlkmth * agcwmlkamt
	replace cowmilklitre = 0 if agcwmlkamt < 0
	replace cowmilklitre = agcwmlkamt if agcwmlkamt> 0 & agcwmlkamt!= . & agcwmlkmth <0
		
	*R2.992 per litre DAFF
	*W1 price = R1.50 (R2.733 DAFF 2008)
	gen cowmilkincome=.
	replace cowmilkincome=cowmilklitre* 2.992
	


*INCOME FROM MILK OR SOUR MILK FROM GOAT

	gen goatmilklitre=.
	replace goatmilklitre = aggtmlkmth * aggtmlkamt
	replace goatmilklitre = 0 if aggtmlkamt < 0
	replace goatmilklitre = aggtmlkamt if aggtmlkamt> 0 & aggtmlkamt!= . & aggtmlkmth <0
	

	//Assume that price for goat milk is the same as price for cow milk since there was no other reference
	gen goatmilkincome=.
	replace goatmilkincome=goatmilklitre* 2.992    


*TOTAL INCOME FROM LIVESTOCK-RELATED PRODUCE
egen animalbyprodinc =  rowtotal(egginc cowmilkinc goatmilkincome)

drop eggunits eggunitannual cowmilklitre goatmilklitre
*========================================================================================================================================================

*PART 4 - CALCULATING COST OF INPUTS

*THINGS YOU HAD TO DO TO PRODUCE CROPS

	gen buylabour=.
	replace buylabour=agilabspn
	replace buylabour=0 if buylabour==.
	replace buylabour=0 if buylabour<0

	gen buyfertil=.
	replace buyfertil=agifrtspn
	replace buyfertil=0 if buyfertil==.
	replace buyfertil=0 if buyfertil<0

	gen buymanure=.
	replace buymanure=agimanspn
	replace buymanure=0 if buymanure==.
	replace buymanure=0 if buymanure<0

	gen buychem=.
	replace buychem=agichmspn
	replace buychem=0 if buychem==.
	replace buychem=0 if buychem<0

	gen buyplough=.
	replace buyplough=agiplghspn
	replace buyplough=0 if buyplough==.
	replace buyplough=0 if buyplough<0

	gen buyseeds=.
	replace buyseeds=agiseedspn
	replace buyseeds=0 if buyseeds==.
	replace buyseeds=0 if buyseeds<0

	gen buydip=.
	replace buydip=agidipspn
	replace buydip=0 if buydip==.
	replace buydip=0 if buydip<0

	gen buyvet=.
	replace buyvet=agivetspn
	replace buyvet=0 if buyvet==.
	replace buyvet=0 if buyvet<0

	gen buyfeed=.
	replace buyfeed=agifeedspn
	replace buyfeed=0 if buyfeed==.
	replace buyfeed=0 if buyfeed<0

	gen buyinvest=.
	replace buyinvest=agiinvspn
	replace buyinvest=0 if buyinvest==.
	replace buyinvest=0 if buyinvest<0

	gen buyrepair=.
	replace buyrepair=agirepspn
	replace buyrepair=0 if buyrepair==.
	replace buyrepair=0 if buyrepair<0

egen inputcosts= rowtotal(buylabour buyfertil buymanure buychem buyplough buyseeds buydip buyvet buyfeed buyinvest buyrepair)


*=====================================================================================================================================================

*PART 5 - Aggregation of all income variables
egen agric_inc = rowtotal (producein  animalinc  animalbyprodinc)
gen netagriincome= agric_inc  - inputcosts
replace netagriincome=. if ag==2

keep w3_hhid netagriincome 
rename netagriincome hhagric
replace hhagric=0 if hhagric<0
replace hhagric=hhagric/12
label variable hhagric "Household average monthly income from subsistence agriculture"


sort w3_hhid

save "$DataOUT\hhagric.dta", replace

*-------------------------------------------------------------------------------------------------------------------------------------
*=====================================================================================================================================
*check
